/**
 * Write a description of class MergeSort here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
import java.util.*;


public class MergeSort extends Sort 
{
 public <T extends Comparable<T>> void sortList( ArrayList<T> arr )
 {
     ArrayList<T> sortedList = mergeSort(arr);
     
     arr.clear();
     
     arr.addAll(sortedList);
 }
 
 public static <T extends Comparable<T>> ArrayList<T> mergeSort(ArrayList<T> arr) {
    if (arr.size() <= 1) {
      return arr;
    }
    ArrayList<T> firstHalf = new ArrayList<T>();
    ArrayList<T> secondHalf = new ArrayList<T>();
    for (int i = 0; i < arr.size() / 2; i++) {
      firstHalf.add(arr.get(i));
    }
    for (int i = arr.size() / 2; i < arr.size(); i++) {
      secondHalf.add(arr.get(i));
    }
    return merge(mergeSort(firstHalf), mergeSort(secondHalf));
  }
 
   public static <T extends Comparable<T>> ArrayList<T> merge(ArrayList<T> arr1, ArrayList<T> arr2) {
    if (arr1.size() == 0) {
      return arr2;
    }
    if (arr2.size() == 0) {
      return arr1;
    }
    ArrayList<T> result = new ArrayList<T>();
    T nextElement;
    if (arr1.get(0).compareTo(arr2.get(0)) > 0) {
      nextElement = arr2.get(0);
      arr2.remove(0);
    } else {
      nextElement = arr1.get(0);
      arr1.remove(0);
    }
    result.add(nextElement);
    result.addAll(merge(arr1,arr2));
    return result;
  }
  
}

